/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                ANALYSIS OF CLAUSE SETS                 * */
/* *                                                        * */
/* *  $Module:   ANALYZE                                    * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.48.1.1 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1998/11/30 19:21:46 $                             * */
/* $Author: schmidt $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: analyze.h,v $ */
 
#ifndef _ANALYZE_
#define _ANALYZE_

#include "clause.h"
#include "sort.h"
#include "list.h"
#include "graph.h"
#include "regular.h"

/**************************************************************/
/* Global Variables                                           */
/**************************************************************/

extern BOOL ana_EQUATIONS;
extern BOOL ana_SORTRES;
extern BOOL ana_SORTDECEQUATIONS;

/**************************************************************/
/* Inline Functions                                           */
/**************************************************************/

static __inline__ BOOL ana_Equations()
{
  return ana_EQUATIONS;
}

static __inline__ BOOL ana_SortRestrictions()
{
  return ana_SORTRES;
}

static __inline__ BOOL ana_SortDecreasing()
{
  return ana_SORTDECEQUATIONS;
}


/**************************************************************/
/* Inline Functions                                           */
/**************************************************************/

void ana_AnalyzeProblem(LIST);
void ana_AnalyzeClauses(LIST);
void ana_AutoConfiguration(LIST);
void ana_Print(void);


#endif
