/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *               INPUT OF SPASS CLAUSES                   * */
/* *                                                        * */
/* *  $Module:   CLAUSEINPUT                                * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.46 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1998/07/20 20:56:36 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: clauseinput.h,v $ */

#ifndef _INPUT_
#define _INPUT_

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include "clause.h"
#include "foldfg.h"
#include "flags.h"

/**************************************************************/
/* Structures                                                 */
/**************************************************************/

typedef struct token {
  char   *string;            /* The string of the token */
  int    line;               /* The line where the token occurs */
} *TOKEN, TOKEN_NODE;


/**************************************************************/
/* Input Functions                                            */
/**************************************************************/

void in_Init(void);
void in_Free(void);

void in_TokenPrint(TOKEN);
void in_TokenDelete(TOKEN);

LIST in_Scanner(FILE*);
LIST in_ScanList(FILE*);
LIST in_ExtractList(LIST);
LIST in_ExtractInputList(LIST);

LIST in_ExtractTermList(LIST);
LIST in_NextArgument(LIST);
TERM in_CreateFunctionTerm(LIST);
TERM in_CreateAtomTerm(LIST);
TERM in_CreateFormulaTerm(LIST);

LIST in_CreateClauseSet(char*);

#endif
