/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                     CLOCK                              * */
/* *                                                        * */
/* *  $Module:   CLOCK                                      * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.46.1.1 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1998/11/30 19:28:52 $                             * */
/* $Author: schmidt $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/

/* $RCSfile: clock.h,v $ */

#ifndef _CLOCK_
#define _CLOCK_

#include <sys/times.h>
#include "misc.h"

#if defined(CLOCKS_PER_SEC)
#undef CLOCKS_PER_SEC
#endif

#if ( defined(SOLARIS) || defined(LINUX) )
#define CLOCKS_PER_SEC 100
#elif (defined(SUNOS) || defined(ALPHA))
#define CLOCKS_PER_SEC 60
#else
#define CLOCK_NO_TIMING
#endif

typedef enum {clock_BACKTRACK,clock_OVERALL,clock_INPUT,clock_CNF,clock_REDUCTION,clock_INFERENCE,clock_TRANSL,clock_TYPESIZE} CLOCK_CLOCKS;
typedef struct tms CLOCK_TMS;

void   clock_Init(void);
void   clock_InitCounter(CLOCK_CLOCKS);
void   clock_StartCounter(CLOCK_CLOCKS);
void   clock_StopPassedTime(CLOCK_CLOCKS);
void   clock_StopAddPassedTime(CLOCK_CLOCKS);
float  clock_GetSeconds(CLOCK_CLOCKS);
void   clock_PrintTime(CLOCK_CLOCKS);

#endif
