/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *               NAIVE CNF TRANSLATOR                     * */
/* *                                                        * */
/* *  $Module:   CNF                                        * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.57.1.1 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1998/11/30 19:38:24 $                             * */
/* $Author: schmidt $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: cnf.h,v $ */

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#ifndef _CNF_
#define _CNF_

#include "hasharray.h"
#include "renaming.h"
#include "resolution.h"
#include "search.h"

#include <string.h>
/**************************************************************/
/* Functions                                                 */
/**************************************************************/

static __inline__ BOOL cnf_LabelEqual(char* l1, char* l2)
{
  return strcmp(l1, l2) == 0;
}

TERM          cnf_ApplyDefinitionOnce(TERM, TERM, TERM, TERM);
LIST          cnf_ApplyDefinitionToClause(CLAUSE, TERM, TERM);

BOOL          cnf_ContainsDefinition(TERM, TERM*);
BOOL          cnf_ContainsPredicate(TERM, SYMBOL, TERM*, TERM*, LIST*, LIST*);

TERM          cnf_DeSkolemFormula(LIST);
TERM          cnf_DefConvert(TERM, TERM, TERM*);
void          cnf_FilePrint(TERM, FILE*);
TERM          cnf_DefTargetConvert(TERM, TERM, TERM, LIST, LIST, LIST, LIST, BOOL*);

void          cnf_FilePrintPrefix(TERM, FILE*);
void          cnf_FPrint(TERM, FILE*);
TERM          cnf_Flatten(TERM, SYMBOL);
PROOFSEARCH   cnf_Flotter(LIST, LIST, LIST*, LIST*, HASH, HASH, BOOL, LIST*);
void          cnf_Free(void);

LIST          cnf_HandleDefinition(PROOFSEARCH, LIST, LIST, LIST, LIST);
void          cnf_Init(void);
TERM          cnf_NegationNormalFormula(TERM);
TERM          cnf_ObviousSimplifications(TERM);
TERM  				cnf_SimplifyQuantors(TERM);

LIST          cnf_QueryFlotter(PROOFSEARCH, TERM, LIST*);
void          cnf_StdoutPrint(TERM);

#ifdef DEBUG
void checkClauseListsConsistency(SHARED_INDEX ShIndex);
#endif

#endif
