/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *               CONDENSATION OF CLAUSES                  * */
/* *                                                        * */
/* *  $Module:   CONDENSING                                 * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.48 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1998/07/20 20:56:36 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: condensing.c,v $ */

#include "subsumption.h"
#include "misc.h"
#include "condensing.h"


LIST cond_CondFast(CLAUSE c)
/**********************************************************
  INPUT:   A clause c.
  RETURNS: A list with indexes with respect to c that can
           be deleted due to condensing.
  CAUTION: None.
***********************************************************/
{
  int    vec, i, j, k;
  LIST   indexlist;

  indexlist = list_Nil();
  vec       = vec_ActMax();
  
  for (i = 0; i < clause_Length(c); i++) {
    vec_Push((POINTER) i);
  }
  
  for (k = clause_Length(c) - 1; k >= 0; k--) {
    for (i = vec; i < vec_ActMax(); i++) {
      if ((int)vec_GetNth(i) != k) {
	cont_StartBinding();
	if (unify_Match(cont_LeftContext(),
			clause_GetLiteralTerm(c,k),
			clause_GetLiteralTerm(c,(int)vec_GetNth(i)))) {
	  cont_BackTrack();
	  for (j = vec; j < vec_ActMax(); j++) {
	    if (k == (int)vec_GetNth(j)) {
	      vec_Swap((vec_ActMax() -1) ,j);
	      j = vec_ActMax();
	    }
	  }
	  
	  if (subs_IdcRes(c,vec,(vec_ActMax() -1))) {
	    indexlist = list_Cons((POINTER)k,indexlist);
	    vec_Pop();
	  }
	  
	  i = vec_ActMax()+1;
	}
	else
	  cont_BackTrack();
      }
    }
  }
 
  vec_SetMax(vec);
  return indexlist;
}
