/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                 SIMPLE HASHING                         * */
/* *                                                        * */
/* *  $Module:   HASH                                       * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.44 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1998/07/20 20:56:37 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: hash.h,v $ */

#ifndef _HASH_
#define _HASH_

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include "list.h"


/**************************************************************/
/* Structures                                                 */
/**************************************************************/

#define hash__SIZE 29            /* a prime */

/* Each Entry is a list of pairs <key,value> */
LIST hash_TABLE[hash__SIZE];


/**************************************************************/
/* Inline Functions                                           */
/**************************************************************/

static __inline__ NAT hash_Index(POINTER Key)
{
  return (NAT)Key % hash__SIZE;
}

static __inline__ LIST hash_List(NAT Index)
{
  return hash_TABLE[Index];
}

static __inline__ void hash_PutList(NAT Index, LIST List)
{
  hash_TABLE[Index] = List;
}

static __inline__ void hash_Put(POINTER Key, POINTER Value)
{
  hash_PutList(hash_Index(Key), list_Cons(list_PairCreate((POINTER)Key, Value),
					  hash_List(hash_Index(Key))));
}


/**************************************************************/
/* Functions                                                  */
/**************************************************************/

void    hash_Init(void);
void    hash_Reset(void);
void    hash_ResetWithValue(void (*)());

POINTER hash_Get(POINTER);


#endif


