/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                MISCELLANEOUS                           * */
/* *                                                        * */
/* *  $Module:   MISC                                       * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.70 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1998/12/02 17:47:02 $                             * */
/* $Author: schmidt $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: misc.h,v $ */

#ifndef _MISC_
#define _MISC_

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include <limits.h>
#include "define.h"


/**************************************************************/
/* More basic types and macros                                */
/**************************************************************/

#if defined(TRUE)
#undef TRUE
#endif

#if defined(FALSE)
#undef FALSE
#endif

#ifndef SEEK_END
#define SEEK_END 2
#endif

typedef enum { FALSE=0, TRUE=1 } BOOL;

#define misc_VERSION "V0.95.5 (JW) rs/uh"


typedef void*           POINTER;
typedef unsigned int    NAT;

/* Limits for EARL data types */
static const NAT NAT_MAX = UINT_MAX;


/**************************************************************/
/* Inline Functions                                           */
/**************************************************************/

static __inline__ void misc_Error(void)
{
  fflush(stdout);
  fflush(stderr);
  exit(3);
}


static __inline__ void misc_DumpCore(void)
{
  fflush(stderr);
  fflush(stdout);
  abort();
}


static __inline__ void misc_PrintChar(NAT Number, char Character)
{
  NAT Counter;
  for (Counter = 1; Counter <= Number; Counter++)
    putchar(Character);
}

static __inline__ BOOL misc_SmallerThan(int i, int j)
{
  return (i < j);
}


/**************************************************************/
/* Functions                                                  */
/**************************************************************/

void  misc_DumpCoreOut(const char*);
BOOL  misc_StringIsNumber(const char*);
int   misc_ReturnValue(void);
int   misc_Max(int, int);

FILE* misc_OpenFile(char* , char*);
void  misc_CloseFile(FILE*, char*);

char* misc_StringCopy(const char*);
void  misc_StringFree(char*);
char* misc_IntToString(int);
int   misc_StringToInt(const char*);

#endif
