/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                   PRIORITY QUEUE                       * */
/* *                                                        * */
/* *  $Module:   PQ                                         * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.69 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1998/07/20 20:56:38 $                             * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: pqueue.h,v $ */


#ifndef _PQ_
#define _PQ_

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include "misc.h"

/**************************************************************/
/* Data structures                                            */
/**************************************************************/

typedef struct {
  NAT      maxSize;
  NAT      size;
  POINTER* items;
  BOOL     (*smaller)();
} PQ_NODE, *PRIORITY_QUEUE;


/**************************************************************/
/* Functions                                                  */
/**************************************************************/

static __inline__ NAT pq_Size(PRIORITY_QUEUE PQueue)
{
  return PQueue->size;
}

static __inline__ NAT pq_MaxSize(PRIORITY_QUEUE PQueue)
{
  return PQueue->maxSize;
}

static __inline__ BOOL pq_Empty(PRIORITY_QUEUE PQueue)
{
  return PQueue->size == 0;
}


PRIORITY_QUEUE pq_Create(NAT, BOOL (*)());
void           pq_Delete(PRIORITY_QUEUE);
POINTER        pq_GetMin(PRIORITY_QUEUE);
POINTER        pq_ExtractMin(PRIORITY_QUEUE);
void           pq_Insert(PRIORITY_QUEUE PQueue, POINTER Item);

void           pq_Print(PRIORITY_QUEUE, void (*)());  /* For debugging */

#endif
