/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *             PROOF CHECKING                             * */
/* *                                                        * */
/* $Revision: 0.44 $                                          * */
/* $State: Exp $                                            * */
/* $Date: 1998/12/02 17:47:02 $                                      * */
/* $Author: schmidt $                                       * */
/* *                                                        * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */

/* $RCSfile: proofcheck.h,v $ */

#ifndef _PROOFCHECK_H_
#define _PROOFCHECK_H_

#include "options.h"
#include "unistd.h"

#include <string.h>
#include <ctype.h>
#include <math.h>
#include "define.h"
#include "list.h"
#include "vector.h"

#include "misc.h"
#include "dfg.h"
#include "foldfg.h"
#include "flags.h"
#include "clause.h"
#include "tableau.h"
#include "search.h"
#include "dfg.h"

typedef char* string ;

/* option defaults */
#define pcheck_DEFTIMELIMIT 3            /* time allowed for each spass proof check */
#define pcheck_DEFPROOFFILESUFFIX ".dfg" /* file suffix of generated proof files */

LIST   pcheck_ReduceSPASSProof(LIST);
string pcheck_GenericFilename(string, string);
int    pcheck_SeqProofDepth(LIST);
void   pcheck_DeleteProof(LIST);
string pcheck_StrPrefix(string, int);
string pcheck_StrSuffix(string, int);
int    pcheck_StrLength(string);
void   pcheck_StrDelete(string);
BOOL   pcheck_BuildTableauFromProof(LIST, TABLEAU*);
LIST   pcheck_ConvertTermListToClauseList(LIST);
void   pcheck_TableauToProofTask(TABLEAU, string, string);
BOOL   pcheck_TableauProof(TABLEAU*, LIST);
LIST   pcheck_ParentPointersToParentNumbers(LIST);
LIST   pcheck_ConvertParentsInSPASSProof(PROOFSEARCH, LIST);
void   pcheck_MarkRecursive(LIST); 
LIST   pcheck_ClauseNumberMergeSort(LIST);
void   pcheck_ClauseListRemoveFlag(LIST, CLAUSE_FLAGS);

#endif



