/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *              REGULAR CLAUSES                           * */
/* *                                                        * */
/* *  $Module:   regular                                    * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 1.1 $                                        * */
/* $State: Exp $                                            * */
/* $Date: 1998/12/02 14:46:09 $                             * */
/* $Author: schmidt $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/

/* $RCSfile: regular.h,v $ */

#include "term.h"
#include "foldfg.h"
#include "clause.h"
#include "order.h"

BOOL reg_IsKRegularClause(CLAUSE, int);
/* static BOOL reg_DominatesLiteral(TERM, TERM); */

static __inline__ BOOL reg_IsNonSingularDepthTwoAtom(TERM Lit)
/**************************************************************
  INPUT:   A literal.
  RETURNS: TRUE, if Lit is not singular (i.e. contains more than one
           variable) and its atom has depth one.
***************************************************************/
{
  if (symbol_Equal(term_TopSymbol(Lit), fol_Not())) {
                printf(" Atom depth=%d ", term_Depth(term_FirstArgument(Lit)));
     return (term_Depth(term_FirstArgument(Lit)) == 2) && 
         (list_Length(term_VariableSymbols(Lit)) > 1);
  }
  else {
                printf(" Atom depth=%d ", term_Depth(Lit));
     return (term_Depth(Lit) == 2) && 
         (list_Length(term_VariableSymbols(Lit)) > 1);
  }
}
