/**************************************************************/
/* ********************************************************** */
/* *                                                        * */
/* *                INFERENCE RULES                         * */
/* *                                                        * */
/* *  $Module:   INFRULES                                   * */ 
/* *                                                        * */
/* *                                                        * */
/* $Revision: 0.54 $                                          * */
/* $State: Exp $                                            * */
/* $Date: 1998/07/20 20:56:39 $                                      * */
/* $Author: weidenb $                                       * */
/* *                                                        * */
/* *             Contact:                                   * */
/* *             Christoph Weidenbach                       * */
/* *             MPI fuer Informatik                        * */
/* *             Im Stadtwald                               * */
/* *             66123 Saarbruecken                         * */
/* *             Email: weidenb@mpi-sb.mpg.de               * */
/* *             Germany                                    * */
/* *                                                        * */
/* ********************************************************** */
/**************************************************************/


/* $RCSfile: rules-inf.h,v $ */

#ifndef _INFRULES_
#define _INFRULES_

/**************************************************************/
/* Includes                                                   */
/**************************************************************/

#include "search.h"
#include "rules-split.h"
#include "rules-sort.h"
#include "subst.h"
#include "unify.h"
#include "st.h"
#include "defs.h"

/**************************************************************/
/* Functions                                                  */
/**************************************************************/        

LIST inf_DerivableClauses(PROOFSEARCH, CLAUSE);

LIST inf_EqualityResolution(CLAUSE);
LIST inf_EqualityFactoring(CLAUSE);

LIST inf_MergingParamodulation(CLAUSE, SHARED_INDEX);

LIST inf_Paramodulation(CLAUSE , SHARED_INDEX);
LIST inf_OrderedParamodulation(CLAUSE, SHARED_INDEX);

LIST inf_GenSuperpositionLeft(CLAUSE, SHARED_INDEX, BOOL, BOOL);
LIST inf_GenSuperpositionRight(CLAUSE, SHARED_INDEX, BOOL, BOOL);
LIST inf_BoundedDepthUnitResolution(CLAUSE, SHARED_INDEX, BOOL);
LIST inf_UnitResolution(CLAUSE, SHARED_INDEX);
LIST inf_SimpleHyperResolution(CLAUSE, st_INDEX);
LIST inf_OrderedHyperResolution(CLAUSE, st_INDEX);
LIST inf_GeneralResolution(CLAUSE, SHARED_INDEX);

LIST inf_GeneralFactoring(CLAUSE);

LIST inf_ApplyDefinition(PROOFSEARCH, CLAUSE);

#endif

