PROOFSEARCH cnf_Flotter(LIST AxiomList, LIST ConjectureList, LIST* AxClauses, 
		 LIST* AllLabels,
		 HASH  TermLabelToClauselist, 
		 HASH  ClauseToTermLabellist,
		 BOOL  KeepProofSearch,
		 LIST* Symblist)
/**************************************************************
  INPUT:   A list of axiomformulae,
           a list of conjectureformulae,
	   a pointer to a list in which clauses derived from axiomformulae 
	   are stored,
	   a pointer to a list in which clauses derived from 
	   conjectureformulae are stored,
	   a pointer to a list of all termlabels,
	   a hasharray in which for every termlabel the list of clauses 
	   derived from the term is stored (if DocProof is set),
	   a hasharray in which for every clause the list of labels 
	   of the terms used for deriving the clause is stored (if DocProof 
	   is set),
	   a boolean,
	   a pointer to a list of symbols which have to be deleted later if
	   the ProofSearch object is kept.
  RETURNS: If KeepProofSearch is TRUE, then the ProofSearch object is not
           freed but returned.
	   Else, NULL is returned.
***************************************************************/
{
  HASH         InputClauseToTermLabellist;

  /* Initialisation */

  if(flag_GetFlagValue(flag_FORMULAE2CLAUSE))
    InputClauseToTermLabellist = hsh_Create();
  else 
    InputClauseToTermLabellist = NULL;
}
