#define yyparse dfg_parse

LIST dfg_DFGParser(FILE* File, LIST* Axioms, LIST* Conjectures, LIST* SortDecl)
/**************************************************************
  INPUT:   The input file containing clauses or formulae in DFG syntax.
           Axioms, Conjectures and SortDecl are pointers to lists used
           as return values.
  RETURNS: The list of clauses from File.
  EFFECT:  Reads formulae and clauses from the input file.
           The axioms, conjectures and sort declarations are appended
	   to the respective lists, the lists are not deleted !
	   All lists except the clauselist contain pairs
	   (label, term), where <label> may be NULL, if no
	   label was specified for that term.
***************************************************************/
{

  dfg_Init(File);      /* Initialize the parser and scanner */
  dfg_parse();          /* Invoke the parser */

  /* Remove clause labels and create clauses from the terms */

  /* Deletions */

  scan = list_Nconc(dfg_AXCLAUSES, dfg_CONCLAUSES);

  *Axioms      = list_Nconc(*Axioms, dfg_AXIOMLIST);
  *Conjectures = list_Nconc(*Conjectures, dfg_CONJECLIST);
  *SortDecl    = list_Nconc(*SortDecl, dfg_SORTDECLLIST);

  return scan;
}
