int main(int argc, char* argv[])
{
	
  /* Initialisation */

  InputClauses = dfg_DFGParser(InputStream, &Axioms, &Conjectures, &Sorts); 
  /**************************************************************
  INPUT:   The input file containing clauses or formulae in DFG syntax.
           Axioms, Conjectures and SortDecl are pointers to lists used
           as return values.
  RETURNS: The list of clauses from File.
  EFFECT:  Reads formulae and clauses from the input file.
           The axioms, conjectures and sort declarations are appended
	   to the respective lists, the lists are not deleted !
	   All lists except the clauselist contain pairs
	   (label, term), where <label> may be NULL, if no
	   label was specified for that term.
  ***************************************************************/

  cnf_Init(); /* Depends on Strong Skolemization Flag */

  /* Build conjecture formula and negate it */

  clock_StopPassedTime(clock_INPUT);

  clock_StartCounter(clock_CNF);

  if (list_Empty(InputClauses)) {

    /* Create labels for formulae without them */

    Axioms = list_Nconc(Axioms, Sorts);

    FlotterSearch = cnf_Flotter(Axioms,Conjectures,&InputClauses, &Labellist,
				TermLabelToClauselist, ClauseToTermLabellist,
				flag_GetFlagValue(flag_INTERACTIVE),&Symblist);

    InputClauses   = clause_ListSortWeighed(InputClauses);

  }
  else {
    /* Delete the lists Axioms, Sorts and Conjectures */

      /* Extract list of definitions */
  }

  clock_StopPassedTime(clock_CNF);

  do {

    if (flag_GetFlagValue(flag_INTERACTIVE)) {
      ...
    }
    else {
      ProblemClauses = InputClauses;
      InputClauses   = list_Nil();
    }

    /* Settings */

    Search = top_ProofSearch(Search,ProblemClauses,InputStore);
    /* seems to be main inference routine */

    if (...) {
      if (list_Empty(prfs_EmptyClauses(Search)))
	Result = top_COMPLETION;
      else
	Result = top_PROOF;
    }
   
    /* Stop SPASS immediately */

    /* Deletion */

      printf("\n--------------------------SPASS-STOP------------------------------");
  } while (flag_GetFlagValue(flag_INTERACTIVE) &&
	   (flag_GetFlagValue(flag_TIMELIMIT) != 0));

  /* Deletions and cleanup */
}

